org.hibernate.search.indexes.spi

## Interface IndexManagerType

- All Known Implementing Classes:
    ElasticsearchIndexManagerType, LuceneEmbeddedIndexManagerType

      public interface IndexManagerType

  Since Hibernate Search supports different types of indexing and query technologies, such as embedding Apache Lucene or remote via Elasticsearch, the type of such storage is represented by an instance implementing this interface.

  Instances of implementations of this interface could be used as keys in a Map, so make sure to implement appropriate equals and hashCode functions.

  The purpose is that some components will have to adapt their output depending on the target technology being used, so they might need to know the type. We refrain from using Enums as that would not be extensible, and avoid using the class type of an IndexManager to allow creating multiple custom implementations for the same type of technology.

  Since:
    5.6
  Author:
    Sanne Grinovero, Gunnar Morling
  Experimental
    This type is under active development as part of the Elasticsearch integration. You should be prepared for incompatible changes in future releases.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `AnalyzerStrategy` | `createAnalyzerStrategy(ServiceManager serviceManager, SearchConfiguration cfg)`
    `MissingValueStrategy` | `createMissingValueStrategy(ServiceManager serviceManager, SearchConfiguration cfg)`

- - ### Method Detail

    - #### createAnalyzerStrategy

          AnalyzerStrategy createAnalyzerStrategy(ServiceManager serviceManager,
                                                  SearchConfiguration cfg)

      Parameters:
        `serviceManager` - the service manager
        `cfg` - the Hibernate Search configuration, providing in particular access to configuration properties.
      Returns:
        a newly created strategy of analyzer execution employed by index managers of this family.

    - #### createMissingValueStrategy

          MissingValueStrategy createMissingValueStrategy(ServiceManager serviceManager,
                                                          SearchConfiguration cfg)

      Parameters:
        `serviceManager` - the service manager
        `cfg` - the Hibernate Search configuration, providing in particular access to configuration properties.
      Returns:
        a newly created strategy for missing values employed by index managers of this family.

Copyright © 2006-2017 Red Hat, Inc. All Rights Reserved